import {Route, useRouteMatch} from "react-router-dom"
import * as React from "react";
import {IndeterminateModel} from "@rx-suite/ui";
import {observer} from "mobx-react-lite";
import {AppInstallForm} from "./AppInstallForm";
import {RxModulePackageStore} from "../../stores/RxModulePackageStore";


export const AppInstallPage: React.FunctionComponent = observer(() => {
    const match = useRouteMatch();
    return (
        <Route exact path={`${match.path}/:id`}>
            <IndeterminateModel store={RxModulePackageStore} Component={AppInstallForm}/>
        </Route>
    );
});