import * as React from 'react';
import {BreadModel, makeColumn} from "@rx-suite/ui";
import {RoleStore} from "../../stores/RoleStore";
import {t} from "@lingui/macro";
import {RolesForm} from "./RolesForm";
import {RolesModelTableDeleteButton} from "../../components/roles/RolesModelTableDeleteButton";

export const RolesBreadModel = () => {
    const columns = React.useMemo(() => {
        return [
            makeColumn('name', t`Role`, "string"),
        ]
    }, []);

    const tableProps = {
        replacementActions: {
            Delete: RolesModelTableDeleteButton
        }
    };
    return (
        <BreadModel store={RoleStore} Form={RolesForm} columns={columns} tableProps={tableProps}/>
    )
};