module GemExtensions
  module RxModule
    module Communicator
      def resolve_endpoint(module_id, endpoint)
        endpoint_details(module_id, endpoint)[:url]
      end

      def endpoint_details(module_id, endpoint)
        component = Component.resolve(module_id)
        {
          url: component&.resolve_endpoint(endpoint),
          external_url: component&.resolve_endpoint_external(endpoint),
          authorization: component&.endpoint_authorization(endpoint)
        }
      end
    end
  end
end
